/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// SystemLanguage the model 'SystemLanguage'
type SystemLanguage string

// List of SystemLanguage
const (
	LanguageGerman SystemLanguage = "de"
	LanguageEnglish SystemLanguage = "en"
)

// All allowed values of SystemLanguage enum
var AllowedSystemLanguageEnumValues = []SystemLanguage{
	"de",
	"en",
}

func (v *SystemLanguage) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := SystemLanguage(value)
	for _, existing := range AllowedSystemLanguageEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid SystemLanguage", value)
}

// NewSystemLanguageFromValue returns a pointer to a valid SystemLanguage
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewSystemLanguageFromValue(v string) (*SystemLanguage, error) {
	ev := SystemLanguage(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for SystemLanguage: valid values are %v", v, AllowedSystemLanguageEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v SystemLanguage) IsValid() bool {
	for _, existing := range AllowedSystemLanguageEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to SystemLanguage value
func (v SystemLanguage) Ptr() *SystemLanguage {
	return &v
}

type NullableSystemLanguage struct {
	value *SystemLanguage
	isSet bool
}

func (v NullableSystemLanguage) Get() *SystemLanguage {
	return v.value
}

func (v *NullableSystemLanguage) Set(val *SystemLanguage) {
	v.value = val
	v.isSet = true
}

func (v NullableSystemLanguage) IsSet() bool {
	return v.isSet
}

func (v *NullableSystemLanguage) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSystemLanguage(val *SystemLanguage) *NullableSystemLanguage {
	return &NullableSystemLanguage{value: val, isSet: true}
}

func (v NullableSystemLanguage) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSystemLanguage) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

